# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetPrincipalResult',
    'AwaitableGetPrincipalResult',
    'get_principal',
    'get_principal_output',
]

@pulumi.output_type
class GetPrincipalResult:
    """
    A collection of values returned by getPrincipal.
    """
    def __init__(__self__, id=None, name=None, type=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def type(self) -> Optional[str]:
        return pulumi.get(self, "type")


class AwaitableGetPrincipalResult(GetPrincipalResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetPrincipalResult(
            id=self.id,
            name=self.name,
            type=self.type)


def get_principal(name: Optional[str] = None,
                  type: Optional[str] = None,
                  opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetPrincipalResult:
    """
    Use this data source to retrieve information about a Rancher v2 Principal resource.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_rancher2 as rancher2

    foo = rancher2.get_principal(name="user@example.com")
    ```


    :param str name: The full name of the principal (string)
    :param str type: The type of the identity (string). Defaults to `user`. Only `user` and `group` values are supported (string)
    """
    __args__ = dict()
    __args__['name'] = name
    __args__['type'] = type
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('rancher2:index/getPrincipal:getPrincipal', __args__, opts=opts, typ=GetPrincipalResult).value

    return AwaitableGetPrincipalResult(
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        type=pulumi.get(__ret__, 'type'))


@_utilities.lift_output_func(get_principal)
def get_principal_output(name: Optional[pulumi.Input[str]] = None,
                         type: Optional[pulumi.Input[Optional[str]]] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetPrincipalResult]:
    """
    Use this data source to retrieve information about a Rancher v2 Principal resource.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_rancher2 as rancher2

    foo = rancher2.get_principal(name="user@example.com")
    ```


    :param str name: The full name of the principal (string)
    :param str type: The type of the identity (string). Defaults to `user`. Only `user` and `group` values are supported (string)
    """
    ...
